--/topic Machine level access
--/info
--Accessing low-level machine resources.
--
--<p><code><span style="color: blue;">include</span> adv/machine.e</code></p>

namespace machine

include adv/dll.e
include std/machine.e as std_machine
without warning

public function allocate_string( sequence string, integer cleanup = 0 )
	
	if length( string ) = 0 and cleanup then
		return NULL
	end if
	
	return std_machine:allocate_string( string, cleanup )
end function

public function allocate_wstring( sequence string, integer cleanup = 0 )
	
	if length( string ) = 0 and cleanup then
		return NULL
	end if
	
	return std_machine:allocate_wstring( string, cleanup )
end function

override function peek_string( atom addr )
	
	if addr = NULL then
		return ""
	end if
	
	return eu:peek_string( addr )
end function

public function peek_wstring( atom addr )
	
	if addr = NULL then
		return ""
	end if
	
	return std_machine:peek_wstring( addr )
end function
